package ru.dbotthepony.mc.otm.capability.android;

import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;

public record AndroidFeatureResearchCost(int experience, ItemStack ...items) {
	public boolean matches(Player ply) {
		if (ply.experienceLevel < experience)
			return false;

		for (var stack : items) {
			boolean hit = false;

			if (stack.getTag() == null) {
				for (var inv_stack : ply.getInventory().items) {
					if (inv_stack.is(stack.getItem()) && inv_stack.getCount() >= stack.getCount()) {
						hit = true;
						break;
					}
				}
			} else {
				for (var inv_stack : ply.getInventory().items) {
					if (inv_stack.is(stack.getItem()) && inv_stack.getCount() >= stack.getCount() && inv_stack.getTag() != null && inv_stack.getTag().equals(stack.getTag())) {
						hit = true;
						break;
					}
				}
			}

			if (!hit)
				return false;
		}

		return true;
	}

	public boolean research(Player ply) {
		if (!matches(ply))
			return false;

		if (experience > 0)
			ply.giveExperienceLevels(-experience);

		for (var stack : items) {
			if (stack.getTag() == null) {
				for (var inv_stack : ply.getInventory().items) {
					if (inv_stack.is(stack.getItem()) && inv_stack.getCount() >= stack.getCount()) {
						inv_stack.shrink(stack.getCount());
						break;
					}
				}
			} else {
				for (var inv_stack : ply.getInventory().items) {
					if (inv_stack.is(stack.getItem()) && inv_stack.getCount() >= stack.getCount() && inv_stack.getTag() != null && inv_stack.getTag().equals(stack.getTag())) {
						inv_stack.shrink(stack.getCount());
						break;
					}
				}
			}
		}

		ply.getInventory().setChanged();

		return true;
	}
}
